<?php 
namespace App;

use Plugin\Exception\Error;

use Plugin\DBMS\Manager;

use App\Config\Settings;

class AutoLoader {
	
	private $main_dirs = array (
			"root" 	=> "../",
			"App"	=> "app/",
			"Plugin"=> "Plugin/",
			"src"	=> "src/"
	);
	
	public function __construct(){
		spl_autoload_register(array($this, 'loader'));
	}
	
	private function loader($className){
		$path = explode('\\',$className);
		$c = 0;
		$include = ROOT_DIR;
		foreach($path as $name){
			if ($c == 0){
				if (isset($this->main_dirs[$name])) 
					$include .= $this->main_dirs[$name];
				$c++;
				continue;
			}
			$include.= $name."/";
		}
		//echo "including: $include\n";
		$include = substr($include, 0,-1).".php";
		//include_once $include;
		if (!file_exists($include)){
			Error::throw500("File does not exist:\n$include\n\nFailed to load:$className ".basename($include));
			exit;
		}
		require_once($include);
		
	}
	
	
}

$auto = new AutoLoader();

